/*
 * JBoss, Home of Professional Open Source
 * Copyright 2011 Red Hat Inc. and/or its affiliates and other contributors
 * as indicated by the @authors tag. All rights reserved.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,  
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.arquillian.core.spi;

import org.jboss.arquillian.core.spi.context.Context;

/**
 * LoadableExtension
 *
 * @author <a href="mailto:aslak@redhat.com">Aslak Knutsen</a>
 * @version $Revision: $
 */
public interface LoadableExtension
{
   public void register(ExtensionBuilder builder);

   
   public interface ExtensionBuilder
   {
      <T> ExtensionBuilder service(Class<T> service, Class<? extends T> impl);
      
      ExtensionBuilder observer(Class<?> handler);
      
      ExtensionBuilder context(Class<? extends Context> context);
   }
   
   public static class Validate 
   {
      public static boolean classExists(String className)
      {
         try
         {
            Class.forName(className);
            return true;
         }
         catch (Exception e) 
         {
            return false;
         }
      }
   }
}
